DO WHIL .f.

  DB3MMPO.PRG   (c) 1983  Darwin Systems, Inc.

  AUTHOR:  P. L. Olympia, Ph.D.   -12/25/84-

  PURPOSE: General system for converting dBASE III data into a format
	   usable by MailMerge, DataStar and others

	   Translated from DB2MM.PRG (dBASE II to Mailmerge) by
	   P. L. Olympia, 12/25/84

  FEATURES: 
	o No limit on the number/length of fields to be converted
	o User specifies DBF file during run-time
	o User can specify any or all fields contained in the DBF file
	o User can specify selection criteria that records must satisfy
	   for their fields to be included
	o Built-in error traps via FILE function to prevent
	   abnormal termination. (TEST function not in dBASE III anymore)


  NOTES:
        o COPY STRU EXTE TO filename will create "filename" whose records
	    are the fields of the DBF in use

        o dBASE III and Version 2.4 of dBASE II allow the
                 COPY TO <filename> SDF DELI WITH "  command
            to unload a data base with trimming of trailing blanks

ENDdo whil f

CLEA
SET TALK OFF
@ 1,6 SAY ""
@ 1,61 SAY ""
@ 2,6 SAY ""
@ 2,66 SAY ""
@ 3,6 SAY "    DB3MMPO by P. L. Olympia, (c) 1983,84 Darwin Syste"
@ 3,61 SAY "ms   "
@ 4,6 SAY ""
@ 4,61 SAY ""
@ 5,6 SAY "                  NiceWare Notice"
@ 5,66 SAY ""
@ 6,6 SAY ""
@ 6,66 SAY ""
@ 7,6 SAY " If you find this program useful, don't send me any mo"
@ 7,61 SAY "ney. "
@ 8,6 SAY " Instead, hug someone you like. You are free to share"
@ 8,61 SAY "this "
@ 9,6 SAY " program with friends and foes under two conditions:"
@ 9,66 SAY ""
@ 10,6 SAY ""
@ 10,66 SAY ""
@ 11,6 SAY "   1. Don't ever make any money off of this program"
@ 11,66 SAY ""
@ 12,6 SAY "   2. Don't change anything in the program, including"
@ 12,61 SAY "this "
@ 13,6 SAY "      notice, credits or the program's name. So there."
@ 13,61 SAY "..   "
@ 14,6 SAY ""
@ 14,66 SAY ""
@ 15,6 SAY "Ŀ"
@ 15,61 SAY ""
@ 16,20 SAY "  P. L. Olympia, Ph.D.  "
@ 17,20 SAY "  Darwin Systems, Inc.  "
@ 18,20 SAY "  Data: 301-963-5249    "
@ 19,20 SAY "  Voice: 301-251-0497   "
@ 20,20 SAY ""
@ 22,0
WAIT
*  Define memory variables
STOR ' ' TO mdr1,mdr2
STOR '        ' TO mdbf,mm
STOR CHR(7) TO bell
STOR "," TO comma

STOR .F. TO ok
DO WHIL .NOT. ok

 CLEA
 @  1, 0 SAY "=================================================="
 @  1,50 SAY "=============================="
 @  2, 0 SAY "DB3TMM - dBASE III to MailMerge Conversion "
 @  2,45 SAY "(c) 1983, 1984  Darwin Systems"
 @  3, 0 SAY "=================================================="
 @  3,50 SAY "=============================="
 @  5, 0 SAY "Name of dBASE III DBF File to convert -------------"
 @  5,50 SAY "--->"
 @  5,56 GET mdbf PICT '!!!!!!!!'
 @  6, 0 SAY "Drive Letter (e.g., A, B) containing above file --"
 @  6,50 SAY "--->"
 @  6,56 GET mdr1
 @  9, 0 SAY "Name of MailMerge (.TXT) file to write to --------"
 @  9,50 SAY "--->"
 @  9,56 GET mm PICT '!!!!!!!!'
 @ 10, 0 SAY "Drive Letter for the MailMerge File  -------------"
 @ 10,50 SAY "--->"
 @ 10,56 GET mdr2
 @ 12, 0 SAY "=================================================="
 @ 12,50 SAY "=============================="
 @ 13, 0 SAY "NOTE: If drive letter is left blank,"
 @ 14, 6 SAY "default drive is assumed"
 READ

IF mdbf = ' '
   ?
   ? 'No DBF file provided. Program is aborting'
   RETU
ELSE
   mdbf=TRIM(mdbf)+'.DBF'
ENDIF
*  Formulate filenames
 IF mdr1 # ' '
   STOR mdr1+':'+mdbf TO mdbf
 ENDIF mdr1

 IF AT('.',mm)=0
    STOR mm-'.TXT' TO mm
 ENDIF mm ctns colon

 IF mdr2 # ' '
   STOR mdr2+':'+mm TO mm
 ENDIF mdr2

*		Check if DBF file exists
 IF .NOT. FILE('&mdbf')
   ? bell+'File '+mdbf+' does not exist'
   ?
   ? 'Press <ESC> to abort ... any other key to try again ... '
   WAIT
   STOR SPAC(8) TO mdbf,mm
 ELSE
   STOR .T. TO ok
 ENDIF

ENDDO not ok

RELE mdr1,mdr2
USE &mdbf
COPY STRU EXTE TO temp
USE temp

*    The records of TEMP is the structure of mdbf
*    Show the fields and ask which ones to include
STOR 2 TO mline
STOR 0 to numfld
STOR ' ' TO mfldlst,allvar,allvar2
CLEA
 @ 1,1 SAY '     FIELDNAME  TYPE  LENGTH  (Mark fields to be included with Y)'

 DO WHIL .NOT.EOF()

   STOR 'N' TO minclud

  IF field_type$'CN'
   x=recno()
   @ mline+x,1 SAY STR(x,2)+'.   '+field_name+'  '+field_type+'   '+;
                 STR(field_len,3)+'   Include? (Y/N) -->' GET minclud PICT '!'
   READ

   IF allvar > ' '

     IF LEN(allvar) < 254
        STOR allvar-comma-field_name TO allvar
     ELSE
        STOR allvar2-comma-field_name TO allvar2
     ENDIF length

   ELSE
     STOR TRIM(field_name) TO allvar
   ENDIF allvar

    IF minclud='Y'
       IF mfldlst > ' '
         STOR mfldlst-comma-field_name TO mfldlst
       ELSE
         STOR TRIM(field_name) TO mfldlst
       ENDIF mfldlst 
    ENDIF minclud=Y

 ENDIF fieldtype is C or N

   SKIP
  *  Check if the screen is full
   IF x=22
      CLEA
      STOR -19 TO mline
   ENDIF 22th line

  ENDDO not eof


*  Ask for selection criteria
  USE &mdbf
  STOR ' ' TO sel
  CLEA
  STOR .F. TO ok
  TEXT

    You may impose any selection criteria to preselect any
    records that should be included in the MailMerge file.

    An example of a selection criterion is:

       NAME >='A' .AND. NAME <='B'

    where "NAME" is a field in the data base. This criterion will
    select only those records with Names beginning with A or B.


  ENDTEXT
  WAIT
  STOR .F. TO ok

  DO WHIL .NOT. ok
    CLEA
    ACCE 'Do you want to impose selection criteria? (Y/N)' TO oksel

  IF oksel$'yY'
    ?
    ? 'Your field names are as follows:'
    ? '   '+allvar
    ?
    ?
    ACCE "Enter criteria: " TO sel
*  Check if this is good... The ff is commented out b/c the TEST
*	function is not yet implemented in dBASE III as of 12/84
DO WHIL .f.

    IF  TEST(&sel)=0
      ? bell+sel+'  is an invalid selection criterion'
      ? 'Press any key to continue...'
      STOR ' ' TO sel
      WAIT
    ELSE
      STOR .T. to ok
      STOR ' FOR '+sel TO sel
    ENDIF not test
ENDDO end of comment

      STOR .T. to ok
      STOR ' FOR '+sel TO sel

  ELSE
      STOR .T. to ok
  ENDIF oksel
 ENDDO not ok

*  Write the file now
 COPY TO &mm DELI WITH " FIELD &mfldlst &sel

 ?
 ? '++++ All Done. MailMerge file '+mm+' has been created +++'
* RELE allvar,mfldlst,sel,oksel,comma 
 RETURN

